'''
    Mapseg, a program for segmenting maps and producing OSM polygons
    Copyright (C) 2010 Tim Sheerman-Chase

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 or version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

from shapely.geometry import Polygon
from dp import *

def SimplifyPolysDp(paths, threshold=1.0, anchor = 0):
	#Simpify polygons
	polys = []
	for poly in paths:
		path = poly['path']
		if len(path) == 0: continue
		path.append(path[0])
		simplePoly = simplify_points(path,threshold,anchor)
		#print simplePoly
		if len(simplePoly) < 3:
			continue
		polys.append(simplePoly)
	return polys

def SimplifyPolysDpMultiStart(paths, threshold=1.0):
	#Simpify polygons
	polys = []
	for poly in paths:
		path = poly['path']
		bestCandidate = None
		bestPoints = None
		for anchor in range(len(path)):
			reorderPath = path[anchor:]
			reorderPath.extend(path[:anchor])

			if len(path) == 0: continue
			reorderPath.append(reorderPath[0])
			simplePoly = simplify_points(reorderPath,threshold)
			#print simplePoly

			if bestPoints == None or len(simplePoly) < bestPoints:
				bestPoints = len(simplePoly)
				bestCandidate = {}
				bestCandidate['path'] = simplePoly
				bestCandidate['meta'] = poly['meta']
		if len(bestCandidate['path']) < 3:
			continue
		polys.append(bestCandidate)
	return polys

